﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;

namespace DynamicEditorTypes
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            xamDataGrid1.FieldLayoutInitialized += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs>(xamDataGrid1_FieldLayoutInitialized);
            
            xamDataGrid1.DataItems.Add(new SimpleData());
            xamDataGrid1.DataItems.Add(new SimpleData(true));
            xamDataGrid1.DataItems.Add(new SimpleData(1233.23));
            xamDataGrid1.DataItems.Add(new SimpleData(DateTime.Today));


        }

        void xamDataGrid1_FieldLayoutInitialized(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializedEventArgs e)
        {
            Field f = e.FieldLayout.Fields[0];
            Style st = new Style();
            st.TargetType = typeof(XamComboEditor);
            ComboBoxItemsProvider provider = new ComboBoxItemsProvider();
            provider.ItemsSource = Enum.GetNames(typeof(TypeEnum));
            Setter set = new Setter(XamComboEditor.ItemsProviderProperty, provider);
            st.Setters.Add(set);
            f.Settings.EditorStyle = st;

            e.FieldLayout.Fields[1].Settings.CellValuePresenterStyle = xamDataGrid1.Resources["editorSwitchField"] as Style;
        }
    }

    public class SimpleData
    {
        public TypeEnum DataType { get; set; }
        public object Something { get; set; }
        public SimpleData()
        {
            this.DataType = TypeEnum.String;
            this.Something = "something";
        }
        public SimpleData(object someValue)
        {
            this.Something = someValue;
        }
    }
    public enum TypeEnum { String, Boolean, Int, DateTime, Collection } 
}
